/**
 * JavaScriptによるUIの実装.
 *
 * Version 00.11.00.00
 *
 * このプログラムのライセンスについて。
 * このプログラムは、MITライセンス(The MIT License)の元で公開します。
 * Released under the MIT Licenses.
 *
 * ライセンスの原文は、以下のURLを参照してください。
 * http://www.yscjp.com/licenses/MIT_LICENSE.txt
 *
 * Copyright (c) 2011-2013 Yagyu Teru, http://yscjp.com/
 */
/**
 * このスクリプトを使用するためには、事前に以下のスクリプトをロードする必要があります。
 * jsevent.js
 * jswebutilities.js
 */
var com;
if (!com) com = {};
if (!com.yscjp) com.yscjp = {};
if (!com.yscjp.jsapp) com.yscjp.jsapp = {};
if (!com.yscjp.jsapp.ui) com.yscjp.jsapp.ui = {};

/**
 * JavaScriptによるメニューの実装。
 */
/**
 * メニューバー
 */
com.yscjp.jsapp.ui.MenuBar = function (id) {
    var idValue = id;
    this.getId = function() {
        return idValue;
    };
};

/*(function() {
    this.add = function(menu) {

    };
    this.insert = function(menu, index) {

    };
    this.remove = function(menu) {

    };
    this.addEventListener = function(litener) {

    };
})();*/

/**
 * メニュー
 */
com.yscjp.jsapp.ui.Menu = function (label, shortCut) {
    var labelValue = label;
    var shortCutValue = shortCut;
    this.getLabel = function() {
        return labelValue;
    };
    this.getShortCut = function() {
        return shortCutValue;
    };
};

/*(function() {
    this.add = function(menuItem) {

    };
    this.insert = function(menuItem, index) {

    };
    this.remove = function(menuItem) {

    };
    this.addEventListener = function(litener) {

    };
})();*/

/**
 * メニュー項目
 */
com.yscjp.jsapp.ui.MenuItem = function (label, shortCut) {
    var labelValue = label;
    var shortCutValue = shortCut;
    this.getLabel = function() {
        return labelValue;
    };
    this.getShortCut = function() {
        return shortCutValue;
    };
};

/*(function() {
    this.addEventListener = function(litener) {

    };
})();*/


/**
 * 複数ページを一度にロードできるiframe群を管理するクラス.
 */
com.yscjp.jsapp.ui.MultiPageLoader = function () {};

(function() {
    var STYLE_SUFFIX                = "com_yscjp_jsapp_ui_MultiPageLoader";
    var STYLE_ID                    = STYLE_SUFFIX + "_id_";
    var STYLE_CLASS                 = STYLE_SUFFIX + "_class_";
    var STYLE_ID_LOADER_PANEL       = STYLE_ID + "loader_panel";
    var STYLE_ID_INFORMATION_PANEL  = STYLE_ID + "information_panel";
    var STYLE_ID_MENU_MARK          = STYLE_ID + "menu_mark";
    var STYLE_ID_SELECT_MARK        = STYLE_ID + "select_mark_";
    var STYLE_ID_IFRAME             = STYLE_ID + "iframe_id_";
    var STYLE_CLASS_IFRAME          = STYLE_CLASS + "iframe";
    var STYLE_CLASS_SELECT_MARK     = STYLE_CLASS + "select_mark";
    var META_KEY_NEXT               = STYLE_SUFFIX + "_meta_next";
    var META_KEY_FRAME_NAME         = STYLE_SUFFIX + "_meta_frame_name";
    var MultiPageLoader = com.yscjp.jsapp.ui.MultiPageLoader;
    var loaderPanel = null;
    var informationPanel = null;
    var menuMark = null;
    var frameInfos = new Object();
    var iframeIndex = 0;
    var currentIFrame = null;
    /* 全てのページのロードが終了した時点で呼び出されるリスナーを格納します。 */
    var allPageLoadedListeners = new Array();
    /*
     * ページがクローズする直前に呼び出されるリスナーを格納します。
     * このリスナが、falseを返すか例外を投げた時は、ページの遷移は行いません。
     */
    var pageCloseBeforeListeners = new Array();
    /* ページがクローズした直後に呼び出されるリスナーを格納します。 */
    var pageCloseAfterListeners = new Array();
    /* ページがオープンする直前に呼び出されるリスナーを格納します。 */
    var pageOpenBeforeListeners = new Array();
    /* ページがオープンした直後に呼び出されるリスナーを格納します。 */
    var pageOpenAfterListeners = new Array();
    MultiPageLoader.addEventListener = function (eventName, listener) {

        if (!eventName) {

            return;
        }

        if (!listener) {

            return;
        }

        var array = null;
        if ("allPageLoaded" == eventName) {

            array = allPageLoadedListeners;

        } else if ("pageCloseBefore" == eventName) {

            array = pageCloseBeforeListeners;

        } else if ("pageCloseAfter" == eventName) {

            array = pageCloseAfterListeners;

        } else if ("pageOpenBefore" == eventName) {

            array = pageOpenBeforeListeners;

        } else if ("pageOpenAfter" == eventName) {

            array = pageOpenAfterListeners;
        }

        if (!array) {

            return;
        }

        array.push(listener);
    };
    MultiPageLoader.removeEventListener = function (eventName, listener) {

        if (!eventName) {

            return;
        }

        if (!listener) {

            return;
        }

        var array = null;
        if ("allPageLoaded" == eventName) {

            array = allPageLoadedListeners;

        } else if ("pageCloseBefore" == eventName) {

            array = pageCloseBeforeListeners;

        } else if ("pageCloseAfter" == eventName) {

            array = pageCloseAfterListeners;

        } else if ("pageOpenBefore" == eventName) {

            array = pageOpenBeforeListeners;

        } else if ("pageOpenAfter" == eventName) {

            array = pageOpenAfterListeners;
        }

        if (!array) {

            return;
        }

        for (var i in array) {

            if (listener == array[i]) {

                array.splice(i, 1);
            }
        }
    };
    MultiPageLoader.init = function () {
        __PFunc.init();
    };
    MultiPageLoader.loadHandler = function (e) {
        MultiPageLoader.start(e.target.href);
        e.preventDefault();
    };
    MultiPageLoader.start = function (url) {
        iframeIndex = 0;
        if (!loaderPanel) {
            loaderPanel = document.createElement("div");
            loaderPanel.id = STYLE_ID_LOADER_PANEL;
            informationPanel = document.createElement("div");
            informationPanel.id = STYLE_ID_INFORMATION_PANEL;
            informationPanel = loaderPanel.appendChild(informationPanel);
            menuMark = document.createElement("div");
            menuMark.id = STYLE_ID_MENU_MARK;
            menuMark = informationPanel.appendChild(menuMark);
            document.body.appendChild(loaderPanel);
            com.yscjp.jsapp.JSEvent.addEventListener(menuMark, 'click', __PFunc.closeHdl, false);
        }
        loaderPanel.style.display = "";
        currentIFrame = MultiPageLoader.loadIFrame(url);
        currentIFrame.style.display = "";
    };
    MultiPageLoader.loadIFrame = function (url) {
        var iframe = document.createElement("iframe");
        iframe.id = STYLE_ID_IFRAME + iframeIndex;
        iframe.className = STYLE_CLASS_IFRAME;
        iframe.width="100%";
        iframe.height="100%";
        iframe.frameborder = "0";
        iframe.src = url;
        iframe.style.display = "none";
        if ("undefined" != typeof iframe.onreadystatechange) {
            iframe.onreadystatechange = function () {
                if (this.readyState == "complete") {
                    this.onreadystatechange = null;
                    var e = new Object();
                    e.target = iframe;
                    __PFunc.loadHdl(e);
                }
            };
        } else {
            com.yscjp.jsapp.JSEvent.addEventListener(iframe, 'load', __PFunc.loadHdl, false);
        }
        return loaderPanel.appendChild(iframe);
    };
    MultiPageLoader.displayPegeByName = function (name) {
        var JS = com.yscjp.jsapp.util.JS;
        var target = MultiPageLoader.getIFrameByName(name);
        if (!target) {
            return;
        }
        for (var i in pageCloseBeforeListeners) {
            if (pageCloseBeforeListeners[i]) {
                try {
                    if (false == JS.executeListener(pageCloseBeforeListeners[i])) {
                        return;
                    }
                } catch (e) {
                    return;
                }
            }
        }
        currentIFrame.style.display = "none";
        for (var i in pageCloseAfterListeners) {
            if (pageCloseAfterListeners[i]) {
                try {
                    JS.executeListener(pageCloseAfterListeners[i]);
                } catch (e) {}
            }
        }
        for (var i in pageOpenBeforeListeners) {
            if (pageOpenBeforeListeners[i]) {
                try {
                    JS.executeListener(pageOpenBeforeListeners[i]);
                } catch (e) {}
            }
        }
        target.style.display = "";
        for (var i in pageOpenAfterListeners) {
            if (pageOpenAfterListeners[i]) {
                try {
                    JS.executeListener(pageOpenAfterListeners[i]);
                } catch (e) {}
            }
        }
        currentIFrame = target;
    };
    MultiPageLoader.getWindowByName = function (name) {
        var target = MultiPageLoader.getIFrameByName(name);
        if (!target) {
            return null;
        }
        return target.contentWindow;
    };
    MultiPageLoader.getIFrameByName = function (name) {
        var iframes = loaderPanel.getElementsByTagName('iframe');
        var target = iframes.namedItem(name);
        return target;
    };
    /*
     * プライベートメソッドを管理する内部クラス。
     * トレースを取得する為に、一元管理していつ必要があるため、このような実装方法としている。
     */
    var __PFunc = function () {};
    __PFunc.closeHdl = function (e) {
        var iframes = loaderPanel.getElementsByTagName("iframe");
        for (var i = iframes.length; i > 0; i--) {
            var iframe = iframes[i - 1];
            loaderPanel.removeChild(iframe);
        }
        var divs = informationPanel.getElementsByTagName("div");
        for (var i = divs.length; i > 0; i--) {
            var _div = divs[i - 1];
            if (STYLE_ID_MENU_MARK == _div.id) {
                continue;
            }
            informationPanel.removeChild(_div);
        }
        loaderPanel.style.display = "none";
    };
    __PFunc.loadHdl = function (e) {
        var iframe = e.target;
        com.yscjp.jsapp.JSEvent.removeEventListener(iframe, 'load', __PFunc.loadHdl, false);
        var metas = iframe.contentDocument.getElementsByTagName('meta');
        var title = iframe.contentDocument.title;
        var nextUrl = null;
        var currentIframeId = STYLE_ID_IFRAME + iframeIndex;
        var frameName = currentIframeId;
        var nextMeta = metas.namedItem(META_KEY_NEXT);
        if (nextMeta) {
            nextUrl = nextMeta.content;
        }
        var frameNameMeta = metas.namedItem(META_KEY_FRAME_NAME);
        if (frameNameMeta) {
            frameName = frameNameMeta.content;
        }
        iframe.name = frameName;
        var frameInfo = new Object();
        frameInfo.iframe = iframe;
        frameInfo.name = frameName;
        frameInfo.selectMark = null;
        frameInfos[currentIframeId] = frameInfo;
        if (!nextUrl) {
            if (0 != iframeIndex) {
                frameInfo.selectMark = __PFunc.addSelectMark(title, frameName);
            }
            for (var i in allPageLoadedListeners) {
                if (allPageLoadedListeners[i]) {
                    allPageLoadedListeners[i]();
                }
            }
            return;
        }
        frameInfo.selectMark = __PFunc.addSelectMark(title, frameName);
        iframeIndex++;
        var targetUrl = __PFunc.getFixPath(e.target, nextUrl);
        var execText = "com.yscjp.jsapp.ui.MultiPageLoader.loadIFrame('" + targetUrl + "')";
        setTimeout(execText, 0);
    };
    __PFunc.addSelectMark = function (title, name) {
        var select_div = document.createElement("div");
        select_div.className = STYLE_CLASS_SELECT_MARK;
        select_div.id = STYLE_ID_SELECT_MARK + iframeIndex;
        select_div.style.left = (2.25 * (1 + iframeIndex)) + "em";
        select_div.title = title;
        var frameName = name;
        select_div.onclick = function() {
            MultiPageLoader.displayPegeByName(frameName);
        };
        select_div = informationPanel.appendChild(select_div);
        return select_div;
    };
    __PFunc.getFixPath = function (iframe, nextUrl) {
        var span = iframe.contentDocument.createElement('span');
        span.innerHTML = '<a href="' + nextUrl + '" />';
        var path = span.firstChild.href;
        delete span;
        return path;
    };
    __PFunc.init = function () {
        var anchors = document.getElementsByTagName("a");
        for (var i = 0; i < anchors.length; i++) {
            var anchor = anchors[i];
            if (com.yscjp.jsapp.util.JSHtmlUtil.matchValue(anchor, STYLE_SUFFIX)) {
                com.yscjp.jsapp.JSEvent.addEventListener(anchor, 'click', MultiPageLoader.loadHandler, false);
            }
        }
    };

    //com.yscjp.jsapp.JSEvent.addEventListener(window, "load", __PFunc.init, false);

    com.yscjp.jsapp.util.StackTrace.insert(__PFunc, "com.yscjp.jsapp.ui.MultiPageLoader.__PFunc");
})();

com.yscjp.jsapp.util.StackTrace.insert(com.yscjp.jsapp.ui.MultiPageLoader, "com.yscjp.jsapp.ui.MultiPageLoader");

