var com;
if (!com) com = {};
if (!com.yscjp) com.yscjp = {};
if (!com.yscjp.jsapp) com.yscjp.jsapp = {};


/*
 * JavaScriptによる、スクロールバーの実装
 *
 * Version 0.0.0.1
 *
 * このプログラムのライセンスについて。
 * このプログラムは、MITライセンス(The MIT License)の元で公開します。
 * Released under the MIT Licenses.
 *
 * ライセンスの原文は、以下のURLを参照してください。
 * http://www.yscjp.com/licenses/MIT_LICENSE.txt
 *
 * Copyright (c) 2010 Yagyu Teru, http://yscjp.com/
 *
 */

com.yscjp.jsapp.JSScrollBerBase = function() {};
(function() {
    /*
     * スタイルシートに、必要な内容を追加する。
     */
})();
com.yscjp.jsapp.JSScrollBerBase.prototype.initJSScrollBerBase = function (id, func) {

    /*
     * モジュールのインポート
     */
    var Log = com.yscjp.jsapp.util.Log;
    var JSEvent = com.yscjp.jsapp.JSEvent;
    var HtmlUtil = com.yscjp.jsapp.util.JSHtmlUtil;

    var targetElement = document.getElementById(id);
    if (null == targetElement) {
        throw "com.yscjp.jsapp.JSScrollBer:\"id\" is illegal.";
    }

    var listener = func;

    var scrollber = document.createElement('div');
    var parrent = targetElement.parentNode;
    scrollber = parrent.insertBefore(scrollber, targetElement.nextSibling);
    scrollber.className = 'com_yscjp_scrollberBox';
    var scrollberWidth = scrollber.offsetWidth - scrollber.clientWidth;
    scrollber.style.width = scrollberWidth + 100 + 'px';
    scrollber.style.height = targetElement.offsetHeight + 'px';
    if ('undefined' != typeof targetElement.style.styleFloat) {
        targetElement.style.styleFloat = 'left';
    } else {
        targetElement.style.cssFloat = 'left';
    }
    var lineSize = 20;
    var viewSize = 4;

//    var colors = ["#00ff00", "#ff0000", "#0000ff", "#ff00ff", "#ffff00", "#00ffff", "#000000", "#ffffff"];

    var lineHeight = targetElement.offsetHeight / viewSize;
    scrollber.style.fontSize = lineHeight + 'px';
    for (var i = 0; i < lineSize; i ++) {
        var lineElement = document.createElement('div');
        lineElement = scrollber.appendChild(lineElement);
        lineElement.style.height = lineHeight + 'px';
//        lineElement.style.backgroundColor = colors[i];
        lineElement.id = 'id_' + i;
    }

    var prevPosition = 0;
    var isArrow = false;
    var isUp = false;
    var isDown = false;
    var currentIndex = 0;
    var currentTop = 0;
    var currentRowElement = scrollber.firstChild;
    var prevIndex = 0;
    //var isUpBottun = false;
    function scrollListener(e) {

        if (isArrow) {

            return;
        }

        /*
         * 今どこにいるかを判定する。
         */
        for (var i = 0; i < scrollber.childNodes.length; i++) {

            var rowTop = scrollber.childNodes.item(i).offsetTop - scrollber.offsetTop;
            rowTop = rowTop - scrollber.scrollTop;
            if (0 < rowTop) {
                currentIndex = i - 1;
                currentRowElement = scrollber.childNodes.item(currentIndex);
                currentTop = currentRowElement.offsetTop - scrollber.offsetTop;
                break;
            }
        }
        //Log.debug("currentIndex:" + currentIndex + " currentTop:" + currentTop + " scrollber.offsetTop:" + scrollber.scrollTop);
        if (prevIndex != currentIndex) {
            //Log.debug("EVENT:" + currentIndex);
            prevIndex = currentIndex;
            listener(currentIndex);
        }
        return true;

        if (prevPosition < scrollber.scrollTop) {

            //Log.debug("scroll down");

            /*
             * スクロールダウン
             */
            var borderLine = currentRowElement.offsetTop -
                             currentRowElement.parentNode.offsetTop +
                             (currentRowElement.offsetHeight / 2);
            //Log.debug("currentRowElement.offsetTop" + currentRowElement.offsetTop + " currentRowElement.parentNode.offsetTop:" + currentRowElement.parentNode.offsetTop + " currentRowElement.offsetHeight:" + currentRowElement.offsetHeight);
            //Log.debug("borderLine" + borderLine + " scrollber.scrollTop:" + scrollber.scrollTop);
            if (borderLine <= scrollber.scrollTop) {
                /*
                 * 一定の基準を越えたいたら、次の行に移動する。
                 */
                var nextRowElement = currentRowElement.nextSibling;
                if (null == nextRowElement) {
                    return;
                }

                /*
                 * アロー部分をクリックしている場合、スクロール位置を指定単位に調整する。
                 */
                if (isArrow) {

//                    scrollber.scrollTop = nextRowElement.offsetTop -
//                                          currentRowElement.offsetParent.offsetTop;
                }
                //Log.debug("scrollber.scrollTop:" + scrollber.scrollTop + " Line:" + );
                currentRowElement = nextRowElement;
            }
        } else {

            //Log.debug("scroll up");

            /*
             * スクロールアップ
             */
            var borderLine = currentRowElement.offsetTop -
                             currentRowElement.parentNode.offsetTop +
                             (currentRowElement.offsetHeight / 2);
        }
//        Log.debug(scrollber.scrollTop);
        prevPosition = scrollber.scrollTop;
    }
    JSEvent.addEventListener(scrollber, "scroll", scrollListener, false);

    //function 

    function mdown(e) {
        e = JSEvent.createEvent(e);
        var bottom = scrollber.offsetHeight - scrollberWidth;
        if (e.offsetY <= scrollberWidth) {
            isArrow = true;
            isUp = true;
            isDown = false;
            Log.debug("Up Arrow Click");
        } else if (bottom <= e.offsetY) {
            isArrow = true;
            isUp = false;
            isDown = true;
            Log.debug("Down Arrow Click");
        }
        Log.debug("mousedown:" + e.clientX + "/" + e.clientY + " offsetX:" + e.offsetX + " offsetY:" + e.offsetY);
    }
    function mup(e) {
        e = JSEvent.createEvent(e);
        Log.debug("mouseup");
        if (isArrow) {

            /*
             * アローボタン押下
             */
            var gotoElement;
            if (isUp) {

                gotoElement = currentRowElement.previousSibling;

            } else {

                gotoElement = currentRowElement.nextSibling;
            }

            if (null == gotoElement) {

                return;
            }

            scrollber.scrollTop = gotoElement.offsetTop - currentRowElement.offsetParent.offsetTop;
            currentRowElement = gotoElement;
            //return;
        }
        isArrow = false;
        isUp = false;
        isDown = false;
        scrollListener(null);
    }
    function mout(e) {
        e = JSEvent.createEvent(e);
        Log.debug("mouseout");
        if (isArrow) {

            /*
             * アローボタン押下
             */
            var gotoElement;
            if (isUp) {

                gotoElement = currentRowElement.previousSibling;

            } else {

                gotoElement = currentRowElement.nextSibling;
            }

            if (null == gotoElement) {

                return;
            }

            scrollber.scrollTop = gotoElement.offsetTop - currentRowElement.offsetParent.offsetTop;
            currentRowElement = gotoElement;
            //return;
        }
        isArrow = false;
        isUp = false;
        isDown = false;
        scrollListener(null);
    }
    JSEvent.addEventListener(scrollber, "mousedown", mdown, false);
    JSEvent.addEventListener(scrollber, "mouseup", mup, false);
    JSEvent.addEventListener(scrollber, "mouseout", mout, false);

}

com.yscjp.jsapp.JSScrollBer = function(id, func) {
    this.initJSScrollBerBase(id, func);
};
com.yscjp.jsapp.JSScrollBer.prototype = new com.yscjp.jsapp.JSScrollBerBase();


