package com.yscjp.webtools.robot.servlet;

import java.io.IOException;
import java.net.InetAddress;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.yscjp.webtools.robot.ModifyKey;
import com.yscjp.webtools.robot.MouseButton;
import com.yscjp.webtools.share.servlet.AutoregisterServletBase;


public abstract class RobotServletBase extends AutoregisterServletBase {

    private static final long serialVersionUID = 1L;

    @Override
    protected void doGet(HttpServletRequest request,
                         HttpServletResponse response) throws ServletException, IOException {

        execute(request, response);
    }


    @Override
    protected void doPost(HttpServletRequest request,
                          HttpServletResponse response) throws ServletException, IOException {

        execute(request, response);
    }


    private void execute(final HttpServletRequest request,
                         final HttpServletResponse response) throws ServletException, IOException {

        Log LOG = LogFactory.getLog(this.getClass());

        String hostName = request.getRemoteAddr();
        InetAddress remoteAddress = InetAddress.getByName(hostName);
        LOG.debug(hostName);
        if (!remoteAddress.isLoopbackAddress()) {

            LOG.error("ローカルホスト以外からのリクエストは、処理できません。");
            return;
        }

        request.setCharacterEncoding("UTF-8");

        final Map<String, String> parameterMap = getParameterMap(request);

        LOG.info(request.getRequestURL() + "?" + request.getQueryString());

        try {

            String delayedFire = request.getParameter("DelayedFire");
            if (null != delayedFire) {

                final int delaye = Integer.parseInt(delayedFire);

                new Thread() {

                    @Override
                    public void run() {

                        try {

                            Thread.sleep(delaye);

                        } catch (InterruptedException e) {

                            e.printStackTrace();
                        }

                        doExecute(parameterMap);
                    }

                }.start();

            } else {

                doExecute(parameterMap);
            }

        } catch (Exception e) {

            LOG.error(e);
            response.setStatus(500);
            return;
        }

        response.setContentType("text/plain");
        response.setHeader("Access-Control-Allow-Origin", "*");
        response.getWriter().write("success");
    }


    private Map<String, String> getParameterMap(HttpServletRequest request) {

        Map<String, String> map = new HashMap<String, String>();

        Map<String, String[]> parameterMap = request.getParameterMap();
        Set<Entry<String, String[]>> entrySet = parameterMap.entrySet();
        for (Entry<String, String[]> entry : entrySet) {

            String key = entry.getKey();
            String[] values = entry.getValue();
            if (0 < values.length) {
                String value = values[0];
                map.put(key, value);
            }
        }

        return map;
    }


    protected int getParameterD2I(Map<String, String> parameterMap, String name) {

        String str = parameterMap.get(name);
        return (int)Math.round(Double.parseDouble(str));
    }


    protected int getParameterInt(Map<String, String> parameterMap, String name) {

        String str = parameterMap.get(name);
        return Integer.parseInt(str);
    }


    protected MouseButton getMouseButton(Map<String, String> parameterMap) {

        boolean isLeftButton = "true".equals(parameterMap.get("LeftButton"));
        boolean isCenterButton = "true".equals(parameterMap.get("CenterButton"));
        boolean isRightButton = "true".equals(parameterMap.get("RightButton"));

        return new MouseButton(isLeftButton, isCenterButton, isRightButton);
    }


    protected ModifyKey getModifyKey(Map<String, String> parameterMap) {

        boolean isCtrlKey = "true".equals(parameterMap.get("CtrlKey"));
        boolean isShiftKey = "true".equals(parameterMap.get("ShiftKey"));
        boolean isAltKey = "true".equals(parameterMap.get("AltKey"));
        boolean isMetaKey = "true".equals(parameterMap.get("MetaKey"));

        return new ModifyKey(isCtrlKey, isShiftKey, isAltKey, isMetaKey);
    }


    protected abstract void doExecute(Map<String, String> parameterMap);
}
